//this file is part of eMule
//created by Ornis
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// CatDialog.cpp : implementation file

#include "stdafx.h"
#include "eMule.h"
#include "CatDialog.h"
#include "Preferences.h"
#include "otherfunctions.h"
#include "AddBuddy.h"

// CCatDialog dialog

IMPLEMENT_DYNAMIC(CCatDialog, CDialog)
CCatDialog::CCatDialog(int index)
	: CDialog(CCatDialog::IDD, 0)
{
	m_pCat = CCat::GetCatByIndex(index);
	if (m_pCat == NULL)
		return;
}

BOOL CCatDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	Localize();
	UpdateData();

	AddBuddy(GetDlgItem(IDC_INCOMING)->m_hWnd, GetDlgItem(IDC_BROWSE)->m_hWnd, BDS_RIGHT);

	return true;
}

void CCatDialog::UpdateData()
{
	CString buffer;

	buffer.Format("%s",m_pCat->GetTitle());
	GetDlgItem(IDC_TITLE)->SetWindowText(buffer);

	buffer.Format("%s",m_pCat->GetPath());
	GetDlgItem(IDC_INCOMING)->SetWindowText(buffer);

	buffer.Format("%s",m_pCat->GetComment());
	GetDlgItem(IDC_COMMENT)->SetWindowText(buffer);

	COLORREF	selcolor = m_pCat->GetColor();

	m_dwNewColor = m_pCat->GetColor();
	m_ctlColor.SetColor(selcolor);

	buffer.Format("%s",m_pCat->GetAutoCatExt());
	GetDlgItem(IDC_AUTOCATEXT)->SetWindowText(buffer);

	m_cmbPriority.SetCurSel(m_pCat->GetPriority());
}

CCatDialog::~CCatDialog()
{
}

void CCatDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CATCOLOR, m_ctlColor);
	DDX_Control(pDX, IDC_PRIOCOMBO, m_cmbPriority);
}


BEGIN_MESSAGE_MAP(CCatDialog, CDialog)
	ON_BN_CLICKED(IDC_BROWSE, OnBnClickedBrowse)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_MESSAGE(CPN_SELENDOK, OnSelChange) //CPN_SELCHANGE
END_MESSAGE_MAP()

// CCatDialog message handlers

void CCatDialog::Localize()
{
	CString buffer;
	
	GetDlgItem(IDC_STATIC_TITLE)->SetWindowText(GetResString(IDS_TITLE));

	buffer.Format("%s", GetResString(IDS_PW_INCOMING));
	buffer.Replace(":", "");
	GetDlgItem(IDC_STATIC_INCOMING)->SetWindowText(buffer);
	GetDlgItem(IDC_STATIC_COMMENT)->SetWindowText(GetResString(IDS_COMMENT));
	GetDlgItem(IDCANCEL)->SetWindowText(GetResString(IDS_CANCEL));
	GetDlgItem(IDC_STATIC_COLOR)->SetWindowText(GetResString(IDS_COLOR));
	GetDlgItem(IDC_STATIC_PRIO)->SetWindowText(GetResString(IDS_STARTPRIO));
	GetDlgItem(IDC_STATIC_AUTOCAT)->SetWindowText(GetResString(IDS_AUTOCAT_LABEL));

	m_ctlColor.CustomText = _T(GetResString(IDS_COL_MORECOLORS));
	m_ctlColor.DefaultText = _T(GetResString(IDS_DEFAULT));
	m_ctlColor.SetDefaultColor(NULL);

	SetWindowText(GetResString(IDS_CAT_EDIT));

	while (m_cmbPriority.GetCount()>0) m_cmbPriority.DeleteString(0);
	m_cmbPriority.AddString(GetResString(IDS_DONTCHANGE));
	m_cmbPriority.AddString(GetResString(IDS_PRIOLOW));
	m_cmbPriority.AddString(GetResString(IDS_PRIONORMAL));
	m_cmbPriority.AddString(GetResString(IDS_PRIOHIGH));
	m_cmbPriority.AddString(GetResString(IDS_PRIOAUTO));
	m_cmbPriority.SetCurSel(m_pCat->GetPriority());
}

void CCatDialog::OnBnClickedBrowse()
{	
//	TCHAR buffer[MAX_PATH] = {0};
//	GetDlgItemText(IDC_INCOMING, buffer, ARRSIZE(buffer));
//	if(SelectDir(GetSafeHwnd(), buffer,GetResString(IDS_SELECTOUTPUTDIR)))
//	CString newpath = BrowseFolder(g_eMuleApp.m_pdlgEmule->m_hWnd,GetResString(IDS_SELECTOUTPUTDIR),dir);
//		GetDlgItem(IDC_INCOMING)->SetWindowText(buffer);

	CString dir;
	GetDlgItemText(IDC_INCOMING, dir);

	CString newpath = BrowseFolder(GetSafeHwnd(),GetResString(IDS_SELECTOUTPUTDIR),dir);

	if(newpath!=dir)
		GetDlgItem(IDC_INCOMING)->SetWindowText(newpath);
}

void CCatDialog::OnBnClickedOk()
{
	CString oldpath=CString(m_pCat->GetPath());

	TCHAR		strTitle[64];
	TCHAR		strPath[MAX_PATH];
	TCHAR		strComment[255];

	if (GetDlgItem(IDC_TITLE)->GetWindowTextLength()>0)
		GetDlgItem(IDC_TITLE)->GetWindowText(strTitle,64);
	m_pCat->m_strTitle = strTitle;

	if (GetDlgItem(IDC_INCOMING)->GetWindowTextLength()>2)
	{
		GetDlgItem(IDC_INCOMING)->GetWindowText(strPath,MAX_PATH);
		//m_pCat->m_strSavePath = strPath;

		::MakeFolderName(strPath);
		m_pCat->m_strSavePath = strPath;

		if (!g_eMuleApp.m_pGlobPrefs->IsShareableDirectory(m_pCat->GetPath()))
		{
			_tcscpy(strPath,g_eMuleApp.m_pGlobPrefs->GetIncomingDir());
			::MakeFolderName(strPath);
			m_pCat->m_strSavePath = strPath;
		}
		if (!PathFileExists(m_pCat->GetPath()))
			::CreateDirectory(m_pCat->GetPath(),0);

		CString newpath = m_pCat->GetPath();

		if (newpath.CompareNoCase(oldpath)!=0)
		{
			CString strCatPath = m_pCat->GetPath();
			bool founddir = false;

			if (strCatPath.GetLength() != 3)
				strCatPath = strCatPath + _T("\\");

			for (POSITION pos = g_eMuleApp.m_pGlobPrefs->m_sharedDirList.GetHeadPosition();pos != 0;g_eMuleApp.m_pGlobPrefs->m_sharedDirList.GetNext(pos))
				if (g_eMuleApp.m_pGlobPrefs->m_sharedDirList.GetAt(pos) == strCatPath)
				{
					founddir = true;
					break;
				}

			if(!founddir)
			{
				g_eMuleApp.m_pGlobPrefs->m_sharedDirList.AddTail(strCatPath);
				g_eMuleApp.m_pSharedFilesList->Reload();
			}
		}
	}

	GetDlgItem(IDC_COMMENT)->GetWindowText(strComment,255);
	m_pCat->m_strComment = strComment;

	m_pCat->m_crColor = m_dwNewColor;
	m_pCat->m_iPriority = m_cmbPriority.GetCurSel();

	TCHAR		strAutoCatExt[255];

	GetDlgItem(IDC_AUTOCATEXT)->GetWindowText(strAutoCatExt,255);
	m_pCat->m_strAutoCatExt = strAutoCatExt;

	g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.Invalidate();

	OnOK();
}

LONG CCatDialog::OnSelChange(UINT lParam, LONG wParam)
{
	if (lParam==CLR_DEFAULT)
		m_dwNewColor=0;		
	else
		m_dwNewColor = m_ctlColor.GetColor();
	
	return TRUE;
}
