// CommentDialog.cpp : implementation file 
// 

#include "stdafx.h" 
#include "emule.h" 
#include "CommentDialog.h" 

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CommentDialog dialog 

IMPLEMENT_DYNAMIC(CCommentDialog, CDialog) 
CCommentDialog::CCommentDialog(CKnownFile* file) 
   : CDialog(CCommentDialog::IDD, 0) 
{ 
   m_file = file; 
} 

CCommentDialog::~CCommentDialog() 
{ 
} 

void CCommentDialog::DoDataExchange(CDataExchange* pDX) 
{ 
   CDialog::DoDataExchange(pDX); 
   DDX_Control(pDX, IDC_RATELIST, ratebox);//for rate 
} 

BEGIN_MESSAGE_MAP(CCommentDialog, CDialog) 
   ON_BN_CLICKED(IDCOK, OnBnClickedApply) 
   ON_BN_CLICKED(IDCERASE, OnBnClickedErase)
   ON_BN_CLICKED(IDCCANCEL, OnBnClickedCancel) 
END_MESSAGE_MAP() 

void CCommentDialog::OnBnClickedApply() 
{ 
	EMULE_TRY

	CString SValue; 
	GetDlgItem(IDC_CMT_TEXT)->GetWindowText(SValue);
	// DonGato + Cax2 (no empty comments)
	if(SValue != "" || ((int8)ratebox.GetCurSel() != 0))
	{ 
		int ratio;
		if((int8)ratebox.GetCurSel() == 4)
			ratio = 3;
		else if ((int8)ratebox.GetCurSel() == 3)
			ratio = 4;
		else
			ratio = (int8)ratebox.GetCurSel();

		m_file->SetFileComment(SValue);
		m_file->SetFileRating(static_cast<_EnumPartFileRating>(ratio));//for Rate//
		CDialog::OnOK();
	}
	else
	{
		AfxMessageBox(GetResString(IDS_CMT_NOCOMMENT));
	}

	EMULE_CATCH
} 

void CCommentDialog::OnBnClickedErase() 
{
	EMULE_TRY

	if(AfxMessageBox(GetResString(IDS_ERASE_SURE), MB_YESNO) == IDYES)
	{
		m_file->RemoveFileCommentAndRating();
		CDialog::OnOK();
	}

	EMULE_CATCH
}

void CCommentDialog::OnBnClickedCancel() 
{ 
   CDialog::OnCancel(); 
} 

BOOL CCommentDialog::OnInitDialog(){ 
   CDialog::OnInitDialog(); 
   Localize(); 

   GetDlgItem(IDC_CMT_TEXT)->SetWindowText(m_file->GetFileComment()); 
   ((CEdit*)GetDlgItem(IDC_CMT_TEXT))->SetLimitText(50);

   return TRUE; 
} 

void CCommentDialog::Localize(void)
{ 
	EMULE_TRY

	GetDlgItem(IDCOK)->SetWindowText(GetResString(IDS_PW_APPLY)); 
	GetDlgItem(IDCCANCEL)->SetWindowText(GetResString(IDS_CANCEL)); 
	GetDlgItem(IDCERASE)->SetWindowText(GetResString(IDS_ERASE)); 
	
	GetDlgItem(IDC_CMT_LQUEST)->SetWindowText(GetResString(IDS_CMT_QUEST)); 
	GetDlgItem(IDC_CMT_LAIDE)->SetWindowText(GetResString(IDS_CMT_AIDE)); 
	
	GetDlgItem(IDC_RATEQUEST)->SetWindowText(GetResString(IDS_CMT_RATEQUEST)); 
	GetDlgItem(IDC_RATEHELP)->SetWindowText(GetResString(IDS_CMT_RATEHELP)); 
	
	while (ratebox.GetCount()>0)
		ratebox.DeleteString(0); 
	
	ratebox.AddString(GetResString(IDS_CMT_NOTRATED));
	ratebox.AddString(GetResString(IDS_CMT_FAKE));
	ratebox.AddString(GetResString(IDS_CMT_POOR));
	ratebox.AddString(GetResString(IDS_CMT_FAIR));
	ratebox.AddString(GetResString(IDS_CMT_GOOD));
	ratebox.AddString(GetResString(IDS_CMT_EXCELLENT));

	int ratio;
	if(m_file->GetFileRating() == PF_RATING_FAIR)
		ratio = 3;
	else if (m_file->GetFileRating() == PF_RATING_GOOD)
		ratio = 4;
	else
		ratio = static_cast<int>(m_file->GetFileRating());

	if(ratebox.SetCurSel(ratio)==CB_ERR)
		ratebox.SetCurSel(0); 
	 
	CString strTitle; 
	
	strTitle.Format(GetResString(IDS_CMT_TITLE),m_file->GetFileName());
	//AfxFormatString1(title,IDS_CMT_TITLE,m_file->GetFileName()); 
	
	SetWindowText(strTitle); 

	EMULE_CATCH
} 
