// FDTransfer.cpp : implementation file
//

#include "stdafx.h"
#include "FDTransfer.h"
#include "..\eMule.h"
#include "..\otherfunctions.h"

// CFDTransfer dialog

IMPLEMENT_DYNCREATE(CFDTransfer, CPropertyPage)

CFDTransfer::CFDTransfer() : CPropertyPage(CFDTransfer::IDD)
{
	//{{AFX_DATA_INIT(CFDTransfer)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDTransfer::~CFDTransfer()
{
}

void CFDTransfer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDTransfer)
	DDX_Control(pDX, IDC_TRANSFERRINGSRC_VAL, m_ctrlTransferringSources);
	DDX_Control(pDX, IDC_TRANSFERRED_VAL, m_ctrlTransferred);
	DDX_Control(pDX, IDC_PARTCNT_VAL, m_ctrlPartCnt);
	DDX_Control(pDX, IDC_LASTSEENCOMPLETE_VAL, m_ctrlLastSeenComplete);
	DDX_Control(pDX, IDC_ICHRECOVERED_VAL, m_ctrlICHrecovered);
	DDX_Control(pDX, IDC_FOUNDSRC_VAL, m_ctrlFoundSources);
	DDX_Control(pDX, IDC_DATARATE_VAL, m_ctrlDatarate);
	DDX_Control(pDX, IDC_COMPLETEDSIZE_VAL, m_ctrlCompletedSize);
	DDX_Control(pDX, IDC_AVAILABLEPARTS_VAL, m_ctrlAvailableParts);
	DDX_Control(pDX, IDC_LASTRECEPTION_VAL, m_ctrlLastReception);
	DDX_Control(pDX, IDC_COMPPERC_VAL, m_ctrlCompPerc);
	DDX_Control(pDX, IDC_CORRUPTIONLOSS_VAL, m_ctrlCorruptionLoss);
	DDX_Control(pDX, IDC_COMPRESSIONGAIN_VAL, m_ctrlCompressionGain);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFDTransfer, CPropertyPage)
	//{{AFX_MSG_MAP(CFDTransfer)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDTransfer message handlers
/////////////////////////////////////////////////////////////////////////////

void CFDTransfer::Update()
{
	EMULE_TRY

	if (m_pFile == NULL)
		return;

	if (!::IsWindow(GetSafeHwnd()))
		return;

	CString strBuffer;

	strBuffer.Format(_T("%i"), m_pFile->GetSourceCount());
	m_ctrlFoundSources.SetWindowText(strBuffer);
	strBuffer.Format(_T("%i"), m_pFile->GetTransferringSrcCount());
	m_ctrlTransferringSources.SetWindowText(strBuffer);
	
	strBuffer.Format(_T("%i (%i)"), m_pFile->GetPartCount(), m_pFile->GetHashCount());
	m_ctrlPartCnt.SetWindowText(strBuffer);

	double		dblPartsPercent = 0.0;

	if (m_pFile->GetPartCount() > 0.0)
	{
		dblPartsPercent = static_cast<double>((m_pFile->GetAvailablePartCount()*100.0) / m_pFile->GetPartCount());
	}
	strBuffer.Format(_T("%i (%.1f%%)"),m_pFile->GetAvailablePartCount(),dblPartsPercent);
	m_ctrlAvailableParts.SetWindowText(strBuffer);
	
	if (m_pFile->lastseencomplete == NULL)
	{	
		strBuffer.Format(GetResString(IDS_NEVER)); 
	}
	else
	{	
		strBuffer.Format(_T("%s"), m_pFile->LocalizeLastSeenComplete());
	}
	m_ctrlLastSeenComplete.SetWindowText(strBuffer);
		
	m_ctrlTransferred.SetWindowText(CastItoXBytes(m_pFile->GetTransferred()));
	m_ctrlCompletedSize.SetWindowText(CastItoXBytes(m_pFile->GetCompletedSize()));
	
	if (m_pFile->GetPercentCompleted() >= 0.0)
	{
		strBuffer.Format(_T("%.2f %%"), m_pFile->GetPercentCompleted());
	}
	else
	{
		strBuffer.Format(_T("?"));
	}
	m_ctrlCompPerc.SetWindowText(strBuffer);

	if(m_pFile->GetDataRate() != (uint32)-1)
	{
		strBuffer.Format(_T("%.2f %s"), static_cast<double>(m_pFile->GetDataRate())/1024.0, GetResString(IDS_KBYTESEC));
	}
	else
	{
		strBuffer.Format(_T("? %s"), GetResString(IDS_KBYTESEC));
	}
	m_ctrlDatarate.SetWindowText(strBuffer);
	
	if(m_pFile->GetTransferred() == 0)
	{	
		strBuffer.Format(_T("%s"), GetResString(IDS_NEVER));
	}
	else
	{
		strBuffer.Format(_T("%s"), m_pFile->LocalizeLastDownTransfer());
	}
	m_ctrlLastReception.SetWindowText(strBuffer);
	
	m_ctrlCorruptionLoss.SetWindowText(CastItoXBytes(m_pFile->GetLostDueToCorruption()));
	m_ctrlCompressionGain.SetWindowText(CastItoXBytes(m_pFile->GetGainDueToCompression()));
	strBuffer.Format("%u", m_pFile->TotalPacketsSavedDueToICH());
	m_ctrlICHrecovered.SetWindowText(strBuffer);

	EMULE_CATCH
}

BOOL CFDTransfer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDTransfer::Localize()
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		GetDlgItem(IDC_FOUNDSRC_LBL)->SetWindowText(GetResString(IDS_FD_SOURCES));
		GetDlgItem(IDC_TRANSFERRINGSRC_LBL)->SetWindowText(GetResString(IDS_FD_TRANSI));
		GetDlgItem(IDC_PARTCNT_LBL)->SetWindowText(GetResString(IDS_FD_PARTS));
		GetDlgItem(IDC_AVAILABLEPARTS_LBL)->SetWindowText(GetResString(IDS_INFLST_FILE_PARTAVAILABLE) + _T(":"));
		GetDlgItem(IDC_LASTSEENCOMPLETE_LBL)->SetWindowText(GetResString(IDS_LASTSEENCOMPL));
		GetDlgItem(IDC_TRANSFERRED_LBL)->SetWindowText(GetResString(IDS_SF_TRANS));
		GetDlgItem(IDC_COMPLETEDSIZE_LBL)->SetWindowText(GetResString(IDS_FD_COMPSIZE));
		GetDlgItem(IDC_DATARATE_LBL)->SetWindowText(GetResString(IDS_FD_DATARATE));
		GetDlgItem(IDC_LASTRECEPTION_LBL)->SetWindowText(GetResString(IDS_FD_LASTCHANGE));
		GetDlgItem(IDC_CORRUPTIONLOSS_LBL)->SetWindowText(GetResString(IDS_FD_CORRUPTION));
		GetDlgItem(IDC_COMPRESSIONGAIN_LBL)->SetWindowText(GetResString(IDS_FD_COMPRESSION));
		GetDlgItem(IDC_ICHRECOVERED_LBL)->SetWindowText(GetResString(IDS_FD_RECOVERED));
	}

	EMULE_CATCH
}
