//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//	FriendListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "FriendListCtrl.h"
#include "friend.h"
#include ".\\Details\\ClientDetails.h"
#include "Addfriend.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//	CFriendListCtrl

IMPLEMENT_DYNAMIC(CFriendListCtrl, CListCtrl)
CFriendListCtrl::CFriendListCtrl()
{
}

CFriendListCtrl::~CFriendListCtrl()
{
}

BEGIN_MESSAGE_MAP(CFriendListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT (NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDoubleclick)
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	CFriendListCtrl message handlers
void CFriendListCtrl::Init()
{
	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	RECT rcWindow;
	GetWindowRect(&rcWindow);
	InsertColumn( 0, GetResString(IDS_QL_USERNAME), LVCFMT_LEFT,
	              rcWindow.right - rcWindow.left - 4, 0 );
	m_imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	m_imageList.SetBkColor(RGB(255, 255, 255));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_FRIENDS1), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_FRIENDS2), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_FRIENDS3), 16, 16));
	LoadImgLstIcon(NULL, 0, 0);	// delete temp-icon
	SetImageList(&m_imageList, LVSIL_SMALL);
	g_eMuleApp.m_pFriendList->SetWindow(this);
	g_eMuleApp.m_pFriendList->ShowFriends();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::Localize()
{
	CHeaderCtrl * pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_QL_USERNAME);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(0, &hdi);
	strRes.ReleaseBuffer();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::AddFriend(CFriend* toadd)
{
	uint32 itemnr = GetItemCount();
	itemnr = InsertItem(LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE, itemnr, toadd->m_strName.GetBuffer(), 0, 0, 1, (LPARAM)toadd);
	RefreshFriend(toadd);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::RemoveFriend(CFriend* toremove)
{
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)toremove;
	sint32 result = FindItem(&find);
	if (result != ( -1))
		DeleteItem(result);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::RefreshFriend(CFriend *pFriend)
{
	if (!::IsWindow(GetSafeHwnd()))
		return;

	LVFINDINFO		find;

	find.flags = LVFI_PARAM;
	find.lParam = reinterpret_cast<LPARAM>(pFriend);

	sint32		iIndex = FindItem(&find);
	CString		strTemp;

	strTemp.Format(_T("%s"), pFriend->m_strName);
	SetItemText(iIndex, 0, static_cast<LPCTSTR>(strTemp));

	if (iIndex == -1)
		return;

	uint8		iImageIndex;

	if (!pFriend->m_pLinkedClient)
		iImageIndex = 0;
#ifdef OLD_SOCKETS_ENABLED
	else if (pFriend->m_pLinkedClient->m_pRequestSocket && pFriend->m_pLinkedClient->m_pRequestSocket->IsConnected())
		iImageIndex = 2;
#endif //OLD_SOCKETS_ENABLED
	else
		iImageIndex = 1;

	SetItem(iIndex, 0, LVIF_IMAGE, 0, iImageIndex, 0, 0, 0, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::OnDoubleclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	if (GetSelectionMark() != ( -1) && GetSelectedCount() > 0)
	{
		CFriend * cur_friend = (CFriend*)GetItemData(GetSelectionMark());
		if (g_eMuleApp.m_pGlobPrefs->GetDetailsOnClick() && cur_friend->m_pLinkedClient)
		{
			CClientDetails dialog(GetResString(IDS_CD_TITLE), cur_friend->m_pLinkedClient, this, 0);
			dialog.DoModal();
		}
	}

	EMULE_CATCH
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	POINT point;
	::GetCursorPos(&point);
	CFriend* cur_friend = NULL;

	if (m_menuClient)
		m_menuClient.DestroyMenu();
	m_menuClient.CreatePopupMenu();
	m_menuClient.AddMenuTitle(GetResString(IDS_FRIENDLIST));

	if (GetSelectionMark() != ( -1) && GetSelectedCount() > 0)
	{
		cur_friend = (CFriend*)GetItemData(GetSelectionMark());

		m_menuClient.AppendMenu(MF_STRING, MP_DETAIL, GetResString(IDS_SHOWDETAILS));
		m_menuClient.EnableMenuItem(MP_DETAIL, ((cur_friend->m_pLinkedClient) ? MF_ENABLED : MF_GRAYED));
	}

	m_menuClient.AppendMenu(MF_STRING, MP_ADDFRIEND, GetResString(IDS_ADDAFRIEND));

	if (GetSelectionMark() != ( -1) && GetSelectedCount() > 0)
	{

		m_menuClient.AppendMenu(MF_STRING, MP_REMOVEFRIEND, GetResString(IDS_REMOVEFRIEND));
		m_menuClient.AppendMenu(MF_STRING, MP_MESSAGE, GetResString(IDS_SEND_MSG));
		m_menuClient.AppendMenu(MF_STRING, MP_SHOWLIST, GetResString(IDS_VIEWFILES));
	}
	SetMenu(&m_menuClient);
	m_menuClient.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
	*pResult = 0;
	m_menuClient.DestroyMenu();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CFriendListCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	CFriend * cur_friend = NULL;

	if (GetSelectionMark() != ( -1))
		cur_friend = (CFriend*)GetItemData(GetSelectionMark());
	switch (wParam)
	{
		case MP_MESSAGE:
		{
			if (cur_friend)
			{
				if (cur_friend->m_pLinkedClient)
					g_eMuleApp.m_pdlgEmule->m_wndChat.StartSession(cur_friend->m_pLinkedClient);
				else
				{
					CUpDownClient* chatclient = new CUpDownClient(cur_friend->m_nLastUsedPort, cur_friend->m_dwLastUsedIP, 0, 0, 0);
					chatclient->SetUserName(cur_friend->m_strName);
					if (g_eMuleApp.m_pClientList->AddClient(chatclient))
						g_eMuleApp.m_pdlgEmule->m_wndChat.StartSession(chatclient);
					else
						safe_delete(chatclient);
				}
			}
			break;
		}
		case MP_REMOVEFRIEND:
		{
			if (cur_friend)
				g_eMuleApp.m_pFriendList->RemoveFriend(cur_friend);
			break;
		}
		case MP_ADDFRIEND:
		{
			CAddFriend dialog2;
			dialog2.DoModal();
		}
		break;
		case MP_DETAIL:
		if (cur_friend->m_pLinkedClient)
		{
			CClientDetails dialog(GetResString(IDS_CD_TITLE), cur_friend->m_pLinkedClient, this, 0);
			dialog.DoModal();
		}
		break;
		case MP_SHOWLIST:
		{
			if (cur_friend)
			{
				if (cur_friend->m_pLinkedClient)
					cur_friend->m_pLinkedClient->RequestSharedFileList();
				else
				{
					CUpDownClient* newclient = new CUpDownClient(cur_friend->m_nLastUsedPort, cur_friend->m_dwLastUsedIP, 0, 0, 0);
					newclient->SetUserName(cur_friend->m_strName);
					//eklmn: check if client was inserted in client list
					if (g_eMuleApp.m_pClientList->AddClient(newclient))
						newclient->RequestSharedFileList();
					else
						safe_delete(newclient);
				}
			}
			break;
		}
	}
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CFriendListCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	EMULE_TRY
	
	bool bHandled = false;
	CFriend *pFriend = NULL;

	if (GetSelectionMark() != (-1))
		pFriend = (CFriend*)GetItemData(GetSelectionMark());

	if (nChar == VK_DELETE)
	{
		if (pFriend)
			if( ::MessageBox(NULL, GetResString(IDS_BACKUP_SURE), GetResString(IDS_REMOVEFRIEND),
				MB_ICONQUESTION|MB_YESNO) == IDYES )
				g_eMuleApp.m_pFriendList->RemoveFriend(pFriend);

		bHandled = true;
	}
	else if (nChar == VK_INSERT)
	{
		CAddFriend dialog2;
		dialog2.DoModal();

		bHandled = true;
	}

	if (!bHandled)
		CListCtrl::OnKeyDown(nChar, nRepCnt, nFlags);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
