//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include <sys/timeb.h>
#include "types.h"
#include "MuleListCtrl.h"
#include "Loggable.h"

#ifndef USRMSG_SWITCHUPLOADLIST
#define USRMSG_SWITCHUPLOADLIST	WM_USER + 12
#endif

enum EnumClientFilter
{
	CLI_FILTER_NONE		= 0,
	CLI_FILTER_BANNED	= 1,
	CLI_FILTER_FRIEND	= 2,
	CLI_FILTER_CREDIT	= 3,
};

enum EnumUploadQueueListIcons
{
	QL_ICON_NORMAL = 0,
	QL_ICON_COMPROT,
	QL_ICON_MLDONKEY,
	QL_ICON_EDONKEYHYBRID,
	QL_ICON_CREDIT_ONLY,
	QL_ICON_FRIEND_ONLY,
	QL_ICON_BANNED_ONLY,
	QL_ICON_UNKNOWN,
	QL_ICON_CDONKEY,
	QL_ICON_LMULE,
	QL_ICON_SHAREAZA,
	QL_ICON_SECUREHASH,
};

enum EnumUploadQueueListColumns
{
	QLCOL_USERNAME = 0,
	QLCOL_FILENAME,
	QLCOL_FILEPRIORITY,
	QLCOL_PARTS,
	QLCOL_PROGRESS,
	QLCOL_QLRATING,
	QLCOL_SCORE,
	QLCOL_SFRATIO,
	QLCOL_RFRATIO,
	QLCOL_TIMESASKED,
	QLCOL_LASTSEEN,
	QLCOL_ENTEREDQUEUE,
	QLCOL_BANNED,

	QLCOL_NUMCOLUMNS,
};

// CQueueListCtrl
class CUpDownClient;

class CQueueListCtrl : public CMuleListCtrl, public CLoggable
{
	DECLARE_DYNAMIC(CQueueListCtrl)

public:
	CQueueListCtrl();
	virtual ~CQueueListCtrl();
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	void	Init();
	void	AddClient(CUpDownClient* client, bool reset = true);
	void	RemoveClient(CUpDownClient* client);
	void	UpdateClient(CUpDownClient* client);
	void	Hide() {ShowWindow(SW_HIDE);}
	void	Show() {ShowWindow(SW_SHOW);}
	void	SortInit(int sortCode);	//sortdlg Cax2
	DWORD	m_dwSortTime; //sortdlg Cax2
	void	Localize();

	//DonGato: show filtered list of clients
	void	ShowFilteredList();
	int		GetClientFilterType(CUpDownClient* client);
	int		m_iClientFilter;

	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
protected:
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);

	virtual BOOL OnNMDividerDoubleClick(NMHEADER* pNMHDR, LRESULT* pResult);
	virtual BOOL OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult);

	DECLARE_MESSAGE_MAP()
private:
	bool			m_bSortAscending[QLCOL_NUMCOLUMNS];	 
	CImageList 		m_imageList;
	UINT_PTR		m_hTimer;	// Barry - Refresh the queue every X seconds
	int				m_iColumnMaxWidths[QLCOL_NUMCOLUMNS];
	int				m_iMeasuringColumn;

	static void CALLBACK QueueUpdateTimer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);
public:
	afx_msg void OnNMClick(NMHDR *pNMHDR, LRESULT *pResult);
	/**AK start**/
	afx_msg void OnNMDblclkQueuelist(NMHDR *pNMHDR, LRESULT *pResult);
	/**AK finish**/
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	void RefreshInfo(void);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};

