//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
//#region version strings
#define CURRENT_VERSION	"1j"

#ifndef _DEBUG
	#if !defined(MMX) && !defined(AMD) && !defined(SSE)
		#define CURRENT_VERSION_LONG	_T(CURRENT_VERSION)
	#endif

	#ifdef MMX
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (MMX)")
	#endif

	#ifdef AMD
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (AMD)")
	#endif

	#ifdef SSE
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (SSE)")
	#endif
#else
	#if !defined(MMX) && !defined(AMD) && !defined(SSE)
		#define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" DEBUG")
	#endif

	#ifdef MMX
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (MMX) DEBUG")
	#endif

	#ifdef AMD
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (AMD) DEBUG")
	#endif

	#ifdef SSE
	    #define CURRENT_VERSION_LONG	_T(CURRENT_VERSION##" (SSE) DEBUG")
	#endif
#endif
//#endregion

//#region constants
#define PLUS_VERSION_STR "Plus 1j"
#define CURRENT_PLUS_VERSION	0x010A
#define RSAKEYSIZE				384		//384 bits

// MOD Note: Do not change this part - Merkur
#define CURRENT_VERSION_SHORT	0x30
#define CURRENT_VERSION_CHECK	0x30A
#define	EMULE_PROTOCOL			0x01
// MOD Note: end

#define	EDONKEYVERSION			0x3c
#define PREFFILE_VERSION		0x14 //<<-- last change: reduced .dat, by using .ini
#define PARTFILE_VERSION		0xe0
#define CREDITFILE_VERSION		0x12
#define CREDITFILE_VERSION_29	0x11
#define COMPILE_DATE			__DATE__
#define COMPILE_TIME			__TIME__
#ifdef _DEBUG
#define EMULE_GUID				"EMULE-{4EADC6FC-516F-4b7c-9066-97D893649569}-DEBUG"
#else
#define EMULE_GUID				"EMULE-{4EADC6FC-516F-4b7c-9066-97D893649569}"
#endif

#define	LANCASTFILEREASKTIMEUDP	10000	// LANCAST (moosetea) - File re-ask time for lan clients is 10 seconds, LAN clients never get banned
#define	LANCASTFILEREASKTIMETCP	30000	// LANCAST (moosetea) - TCP File re-ask time for lan clients is 30 seconds, this needs to be more than the UDP limit, again LAN clients never get banned

// MOD Note: Do not change this part - Merkur
#define UDPSEARCHSPEED			1000	// if this value is too low you will miss sources
#define MAX_RESULTS				100 	// max global search results
#define MAX_CLIENTCONNECTIONTRY	2
#define CONNECTION_TIMEOUT		40000	//set this lower if you want less connections at once, set it higher if you have enough sockets (edonkey has its own timout too, so a very high value won't effect this)
#define	FILEREASKTIME			1300000	//** 21:40 min
#define SERVERREASKTIME			800000	// don't set this too low, it wont speed up anything, but it could kill emule or your internetconnection
#define SERVER_SRC_REQ_QUANT		300000	// per 1 quant is allowed 15 source requests
#define UDPSERVERREASKTIME		1300000 //***
#define SOURCECLIENTREASK		600000
#define MINCOMMONPENALTY		9
#define UDPSERVERSTATTIME		5000	//5 secs
#define UDPSERVSTATREASKTIME	14400	//4 hours
#define	UDPSERVERPORT			4665 	//default udp port
// MOD Note: end

#define MAXCONPER5SEC			g_eMuleApp.m_pGlobPrefs->GetMaxConPerSec()
#define RARE_FILE				25  	// Sources to consider a rare file * DO NOT TOUCH *

#define	SEC2MS(sec)		((sec)*1000)
#define	MIN2MS(min)		SEC2MS((min)*60)


#define	UPLOAD_LOW_CLIENT_DR	2400 // uploadspeed per client in bytes - you may want to adjust this if you have a slow connection or T1-T3 ;)
#define	UPLOAD_CLIENT_DATARATE 	3200
#define	MIN_UP_CLIENTS_ALLOWED 	2
#define	MAX_UP_CLIENTS_ALLOWED 	100

#define	UPLOAD_CLIENT_THRESHOLD 5000	// minimum time between starting new uploads
#define MAX_LINES_IN_LOGVIEW	1000	// limit the number of lines shown in the server/log view of the mule

#define DOWNLOADTIMEOUT			120000	// 2min
#define CONSERVTIMEOUT			g_eMuleApp.m_pGlobPrefs->SrvConTimeout() //agelimit for pending connection attempts
#define BADCLIENTBAN 			g_eMuleApp.m_pGlobPrefs->BadClientMinRequestNum()
#define	MIN_REQUESTTIME 		g_eMuleApp.m_pGlobPrefs->BadClientMinRequestTime()
#define	MAX_PURGEQUEUETIME		7200000 //Vorlost doubled clear dead clients timeout
#define CONNECTION_LATENCY		22050 //latency for responses
#define	SOURCESSLOTS			100
#define MINWAIT_BEFORE_DLDISPLAY_WINDOWUPDATE   1000
#define MINWAIT_BEFORE_ULDISPLAY_WINDOWUPDATE   3000
#define MINWAIT_BEFORE_CALCULATE_DL_RATE        1000

#define ASK_FOR_PARTS_ON_UPLOAD g_eMuleApp.m_pGlobPrefs->IsUploadPartsEnabled() // 0 disabled - 1 enabled

// you shouldn't change anything here if you are not really sure, or emule will probaly not work
#define	MAXFRAGSIZE				1300
#define	PARTSIZE				9728000
#define EMBLOCKSIZE				184320
#define MINFIRSTMOVIESIZE		1216000   //Vorlost for LoadRarestFinishedChunks Patch2
#define MINLASTMOVIESIZE		1216000   //= 1/8 of PARTSIZE, less possible... [Vorlost]

#define PURGE_TIME				30000	// purge time for no needed parts sources
#define MAX_QUEUE				10000
#define MIN_QUEUE				1000

// netwolf: ottavios SLS
#define EXPIREIN					g_eMuleApp.m_pGlobPrefs->WhenSourcesOutdated()
#define RELOADTIME					g_eMuleApp.m_pGlobPrefs->RestoreSourcesTime()
#define RESAVETIME					600000 //10 minutes
//#endregion

//#region Enumeration and EnumDomain class defs
template <typename DataType>
class Enumeration
{
	typedef DataType		BaseType;
	typedef const DataType	ConstBaseType;

protected:
	DataType	m_value;

public:
				Enumeration()
					: m_value(0) {}
protected:
				Enumeration(const DataType value)
					: m_value(value) {}
};

template <typename EnumType,class BaseClass = Enumeration<BYTE> >
class EnumDomain : public BaseClass
{
public:
	typedef EnumType	EType;

				EnumDomain()
					: BaseClass() {}
				EnumDomain(const EnumType eValue)
					: BaseClass(static_cast<ConstBaseType>(eValue)) {}

#ifndef VS2002	// Causes an ambiguity in VS 2002
	operator EnumType() { return static_cast<EnumType>(m_value); }
#endif
	operator const EnumType() const { return static_cast<EnumType>(m_value); }
	EnumType operator ++() { return static_cast<EnumType>(++m_value); }
};
//#endregion

//#region packet header and tag codes
enum _EnumProtocols
{
	OP_EDONKEYHEADER	= 0xE3,
	OP_EDONKEYPROT		= OP_EDONKEYHEADER,
	OP_PACKEDPROT		= 0xD4,
	OP_EMULEPROT		= 0xC5,
	OP_LANCASTPROT		= 0xC6,
	OP_MLDONKEYPROT		= 0x00,
};

typedef EnumDomain<_EnumProtocols>		EnumProtocols;

#define	MET_HEADER				0x0E

#define UNLIMITED				0xFFFF

enum _EnumOpcodes
{
//	client <-> server
	OP_LOGINREQUEST				= 0x01,	//<HASH 16><ID 4><PORT 2><1 Tag_set{NICK,EMULEVER,PORT}>
	OP_REJECT					= 0x05,	//(null)
	OP_GETSERVERLIST			= 0x14,	//(null)client->server
	OP_OFFERFILES				= 0x15,	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
	OP_SEARCHREQUEST			= 0x16,	// <Query_Tree>
	OP_DISCONNECT				= 0x18,	// (not verified)
	OP_GETSOURCES				= 0x19,	// <HASH 16>
	OP_SEARCH_USER				= 0x1A,	// <Query_Tree>
	OP_CALLBACKREQUEST			= 0x1C,	// <ID 4>
	OP_QUERY_CHATS				= 0x1D,	// (deprecated not supported by server any longer)
	OP_CHAT_MESSAGE        		= 0x1E, // (deprecated not supported by server any longer)
	OP_JOIN_ROOM				= 0x1F, // (deprecated not supported by server any longer)
	OP_QUERY_MORE_RESULT		= 0x21, // (null)
	OP_SERVERLIST				= 0x32,	// <count 1>(<IP 4><PORT 2>)[count] server->client
	OP_SEARCHRESULT				= 0x33,	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
	OP_SERVERSTATUS				= 0x34,	// <USER 4><FILES 4>
	OP_CALLBACKREQUESTED		= 0x35,	// <IP 4><PORT 2>
	OP_CALLBACK_FAIL			= 0x36,	// (null notverified)
	OP_SERVERMESSAGE			= 0x38,	// <len 2><Message len>
	OP_CHAT_ROOM_REQUEST		= 0x39, // (deprecated not supported by server any longer)
	OP_CHAT_BROADCAST			= 0x3A, // (deprecated not supported by server any longer)
	OP_CHAT_USER_JOIN			= 0x3B, // (deprecated not supported by server any longer)
	OP_CHAT_USER_LEAVE			= 0x3C, // (deprecated not supported by server any longer)
	OP_CHAT_USER				= 0x3D, // (deprecated not supported by server any longer)
	OP_IDCHANGE					= 0x40,	// <NEW_ID 4>
	OP_SERVERIDENT     			= 0x41,	// <HASH 16><IP 4><PORT 2>{1 TAG_SET}
	OP_FOUNDSOURCES				= 0x42,	// <HASH 16><count 1>(<ID 4><PORT 2>)[count]
	OP_USERS_LIST				= 0x43, // <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]

// client <-> client
	OP_HELLO					= 0x01,	// 0x10<HASH 16><ID 4><PORT 2><1 Tag_set> - alias for OP_LOGINREQUEST?
	OP_SENDINGPART				= 0x46,	// <HASH 16><von 4><bis 4><Daten len:(von-bis)>
	OP_REQUESTPARTS				= 0x47,	// <HASH 16><von[3] 4*3><bis[3] 4*3>
	OP_FILEREQANSNOFIL			= 0x48,	// <HASH 16>
	OP_END_OF_DOWNLOAD     		= 0x49, // <HASH 16>
	OP_ASKSHAREDFILES			= 0x4A, // (null)
	OP_ASKSHAREDFILESANSWER 	= 0x4B,	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
	OP_HELLOANSWER				= 0x4C,	// <HASH 16><ID 4><PORT 2><1 Tag_set><SERVER_IP 4><SERVER_PORT 2>
	OP_CHANGE_CLIENT_ID 		= 0x4D,	// <ID_old 4><ID_new 4>
	OP_MESSAGE					= 0x4E,	// <len 2><Message len>
	OP_SETREQFILEID				= 0x4F,	// <HASH 16>
	OP_FILESTATUS				= 0x50,	// <HASH 16><count 2><status(bit array) len:((count+7)/8)>
	OP_HASHSETREQUEST			= 0x51,	// <HASH 16>
	OP_HASHSETANSWER			= 0x52,	// <count 2><HASH[count] 16*count>
	OP_STARTUPLOADREQ			= 0x54,	// <HASH 16>
	OP_ACCEPTUPLOADREQ			= 0x55,	// (null)
	OP_CANCELTRANSFER			= 0x56,	// (null)
	OP_OUTOFPARTREQS			= 0x57,	// (null)
	OP_FILEREQUEST				= 0x58,	// <HASH 16>	(more correctly file_name_request)
	OP_FILEREQANSWER			= 0x59,	// <HASH 16><len 4><NAME len>
	OP_CHANGE_SLOT				= 0x5B,	// <HASH 16>
	OP_QUEUERANK				= 0x5C,	// <wert  4> (slot index of the request)
	OP_ASKSHAREDDIRS        	= 0x5D, // (null)
	OP_ASKSHAREDFILESDIR    	= 0x5E, // <len 2><Directory len>
	OP_ASKSHAREDDIRSANS     	= 0x5F, // <count 4>(<len 2><Directory len>)[count]
	OP_ASKSHAREDFILESDIRANS 	= 0x60, // <len 2><Directory len><count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
	OP_ASKSHAREDDENIEDANS   	= 0x61, // (null)

	OP_UNKNOWNx6A				= 0x6A,	// ??? Hybrid v49,4 (Horde?)
	OP_UNKNOWNx7A				= 0x7A,	// ??? size: 2 data: 00 d2

// extened prot client <-> extened prot client
	OP_EMULEINFO				= 0x01,	//
	OP_EMULEINFOANSWER			= 0x02,	//
	OP_COMPRESSEDPART			= 0x40,	//
	OP_QUEUERANKING				= 0x60,	// <RANG 2>
	OP_FILEDESC					= 0x61,	// <len 2><NAME len>
	OP_VERIFYUPSREQ				= 0x71,	// (never used)
	OP_VERIFYUPSANSWER			= 0x72,	// (never used)
	OP_UDPVERIFYUPREQ			= 0x73,	// (never used)
	OP_UDPVERIFYUPA				= 0x74,	// (never used)
	OP_REQUESTSOURCES			= 0x81,	// <HASH 16>
	OP_ANSWERSOURCES			= 0x82,	//
	OP_PUBLICKEY				= 0x85,	// <len 1><pubkey len>
	OP_SIGNATURE				= 0x86,	// v1: <len 1><signature len>  v2:<len 1><signature len><sigIPused 1>
	OP_SECIDENTSTATE			= 0x87,	// <state 1><rndchallenge 4>

//	extended prot client <-> extended prot client UDP
	OP_REASKFILEPING			= 0x90,	// <HASH 16>
	OP_REASKACK					= 0x91,	// <HASH 16>
	OP_FILENOTFOUND				= 0x92,
	OP_QUEUEFULL				= 0x93,

//	client <-> UDP server
	OP_GLOBSEARCHREQ2			= 0x92,	// <search_tree>
	OP_GLOBSERVSTATREQ			= 0x96,	// (null)
	OP_GLOBSERVSTATRES			= 0x97,	// <USER 4><FILES 4>
	OP_GLOBSEARCHREQ			= 0x98,	// <search_tree>
	OP_GLOBSEARCHRES			= 0x99,	//
	OP_GLOBGETSOURCES			= 0x9A,	// <HASH 16>
	OP_GLOBFOUNDSOURCES			= 0x9B,	//
	OP_GLOBCALLBACKREQ			= 0x9C,	// <ID 4>
	OP_SERVER_LIST_REQ			= 0xA0,	// <IP 4><PORT 2>
	OP_SERVER_LIST_RES			= 0xA1,	// <count 1> (<ip 4><port 2>)[count]
	OP_SERVER_DESC_REQ			= 0xA2,	// (null)
	OP_SERVER_DESC_RES			= 0xA3,	// <name_len 2><name name_len><desc_len 2 desc_en>
	OP_SERVER_LIST_REQ2			= 0xA4,	// (null)

//	Lancast
	OP_HASH						= 0x01,		// Broadcast hash
	OP_HASHSEARCH				= 0x02,		// Search the subnet for a hash
	OP_HASHSEARCHRESPONSE		= 0x03,		// Hash found on this client
	OP_FILESEARCH				= 0x04,		// Search the subnet for a file
	OP_FILESEARCHRESPONSE		= 0x05,		// File found on this client
};

typedef EnumDomain<_EnumOpcodes>	EnumOpcodes;

//	Define a parent domain for all tags
//class EnumPacketTags : public Enumeration<BYTE> {};

enum _EnumServerTags
{
// server tags
	ST_SERVERNAME			= 0x01,	// <string>
	ST_DESCRIPTION			= 0x0B,	// <string>
	ST_PING					= 0x0C,	// <int>
	ST_PREFERENCE			= 0x0E,	// <int>
	ST_FAIL					= 0x0D,	// <int>
	ST_DYNIP				= 0x85,
//	ST_LASTPING				= 0x86,	// <int> No longer used.
	ST_MAXUSERS				= 0x87,
	ST_SOFTFILES			= 0x88,
	ST_HARDFILES			= 0x89,
	ST_LASTPING				= 0x90,	// <int>
	ST_VERSION				= 0x91,	// <string>
	ST_UDPFLAGS				= 0x92,	// <int>
};
typedef EnumDomain<_EnumServerTags>	EnumServerTags;

enum _EnumFileTags
{
	FT_FILENAME				= 0x01,
	FT_FILESIZE				= 0x02,	// <int>
	FT_FILETYPE				= 0x03,	// <string>
	FT_FILEFORMAT			= 0x04,	// <string>
	FT_LASTSEENCOMPLETE		= 0x05,

	FT_TRANSFERRED			= 0x08,	// <int>
	FT_GAPSTART				= 0x09,
	FT_GAPEND				= 0x0A,
	FT_PARTFILENAME			= 0x12,	// <string>
	FT_PRIORITY				= 0x13,
	FT_STATUS				= 0x14,
	FT_SOURCES				= 0x15,
	FT_PERMISSIONS			= 0x16,
	FT_ULPRIORITY			= 0x17,
//	FT_DLPRIORITY			= 0x18,	// Was 13
//	FT_ULPRIORITY			= 0x19,	// Was 17
	FT_CATEGORY				= 0x20,

// statistic
	FT_ATTRANSFERRED		= 0x50,
	FT_ATREQUESTED			= 0x51,
	FT_ATACCEPTED			= 0x52,
	FT_ATTRANSFERREDHI		= 0x54,
};

typedef EnumDomain<_EnumFileTags>	EnumFileTags;

enum _EnumClientTags
{
// client tags, ed2k-prot OP_HELLO
	CT_NAME					= 0x01,
	CT_VERSION				= 0x11,
	CT_PORT					= 0x0f,
	CT_SUPPORTED_FEATURES	= 0x20,
	CT_MOD_VERSION			= 0x55, // Pawcio 4.1; Cyrex2001 0.5; LSD.15b; MorphKad 0.4
	CT_FRIENDSHARING		= 0x66, //[Bloodymad@Vorlost Anti-Friendsharing 0.3]
	CT_EMULE_RESERVED1		= 0xf0, // eMule 0.40 (official)
	CT_EMULE_RESERVED2		= 0xf1, // eMule 0.40 (official)
	CT_EMULE_RESERVED3		= 0xf2, // eMule 0.40 (official)
	CT_EMULE_RESERVED4		= 0xf3, // eMule 0.40 (official)
	CT_EMULE_RESERVED5		= 0xf4, // eMule 0.40 (official)
	CT_EMULE_RESERVED6		= 0xf5, // eMule 0.40 (official)
	CT_EMULE_RESERVED7		= 0xf6, // eMule 0.40 (official)
	CT_EMULE_RESERVED8		= 0xf7, // eMule 0.40 (official)
	CT_EMULE_RESERVED9		= 0xf8, // eMule 0.40 (official)
	CT_EMULE_UDPPORTS		= 0xf9, // eMule 0.40 (official)
	CT_EMULE_MISCOPTIONS1	= 0xfa, // eMule 0.40 (official)
	CT_EMULE_VERSION		= 0xfb, // eMule 0.40 (official)
	CT_EMULE_RESERVED10		= 0xfc, // eMule 0.40 (official)
	CT_EMULE_RESERVED11		= 0xfd, // eMule 0.40 (official)
	CT_EMULE_RESERVED12		= 0xfe, // eMule 0.40 (official)
	CT_EMULE_RESERVED13		= 0xff, // eMule 0.40 (official)

// unknown client tags (friendsharing, DarkMule, ...)
	CT_UNKNOWNx0			= 0x00, // Hybrid Horde protocol
	CT_UNKNOWNx12			= 0x12, // http://www.haspepapa-welt.de (DodgeBoards)
	CT_UNKNOWNx13			= 0x13, // http://www.haspepapa-welt.de (DodgeBoards)
	CT_UNKNOWNx14			= 0x14, // http://www.haspepapa-welt.de (DodgeBoards)
	CT_UNKNOWNx15			= 0x15, // http://www.haspepapa-welt.de (DodgeBoards) & DarkMule |eVorte|X|
	CT_UNKNOWNx16			= 0x16, // http://www.haspepapa-welt.de (DodgeBoards)
	CT_UNKNOWNx17			= 0x17, // http://www.haspepapa-welt.de (DodgeBoards)
	CT_UNKNOWNx22			= 0x22, // DarkMule |eVorte|X|
	CT_UNKNOWNx3c			= 0x3c, // Pawcio
	CT_UNKNOWNx3d			= 0x3d, // Pawcio
	CT_UNKNOWNx63			= 0x63, // ?
	CT_UNKNOWNx64			= 0x64, // ?
	CT_UNKNOWNx68			= 0x68, // ?
	CT_UNKNOWNx69			= 0x69, // DarkMule v6 |eVorte|X|
	CT_UNKNOWNx88			= 0x88, // DarkMule v6 |eVorte|X|
	CT_UNKNOWNx8c			= 0x8c, // eMule v0.27c [LSD7c] 
	CT_UNKNOWNx8d			= 0x8d, // unknown Leecher - (client version:60)
	CT_UNKNOWNx99			= 0x99, // eMule v0.26d [RAMMSTEIN 8b]
	CT_UNKNOWNxbb			= 0xbb, // emule.de (client version:60)
};

typedef EnumDomain<_EnumClientTags>		EnumClientTags;

enum _EnumEmuleTags
{
// emule tags, emule-extend-prot OP_EMULEINFO
	ET_COMPRESSION				= 0x20,
	ET_UDPPORT					= 0x21, 
	ET_UDPVER					= 0x22,
	ET_SOURCEEXCHANGE			= 0x23,
	ET_COMMENTS					= 0x24,
	ET_EXTENDEDREQUEST			= 0x25,
	ET_COMPATIBLECLIENT			= 0x26,
	ET_FEATURES					= 0x27,	// secure credits (official 0.29b)

	ET_INCOMPLETEPARTS			= 0x3D, //<<-- enkeyDEV(th1) -ICS-
	ET_L2HAC					= 0x3E, //<<-- enkeyDEV(th1) -L2HAC-

// mod tags
	ET_MOD_FEATURESET			= 0x54, //[Bloodymad Featureset]
	ET_MOD_VERSION				= 0x55, // Mod ver Generic String
	ET_MOD_PROTOCOL				= 0x56, // Mod ver Extended Mod Protocol
	ET_MOD_PLUS				    = 0x99, //to avoid conflicts with ET_TAROD_VERSION recognized by lugdunum srvers

// identified MOD's 
	ET_MOD_BOWLFISH             = 0x5A,	
	ET_MOD_FUSION				= 0x66,
	ET_MOD_FUSION_VERSION       = 0x67,
	ET_MOD_TAROD				= 0x77,
	ET_MOD_TAROD_VERSION		= 0x78,
	ET_MOD_Morph                = 0x79,
	ET_MOD_Morph_VERSION	    = 0x80,
	ET_MOD_MorTillo				= 0x82,
	ET_MOD_MorTillo_VERSION		= 0x83,
	ET_MOD_LSD				    = 0x87,  
	ET_MOD_LSD_VERSION		    = 0x88,
	ET_MOD_LOVELACE_VERSION		= 0x90,
	ET_MOD_OXY                  = 0x94,

// unknown eMule tags
	ET_MOD_UNKNOWNx12			= 0x12, // http://www.haspepapa-welt.de
	ET_MOD_UNKNOWNx13			= 0x13, // http://www.haspepapa-welt.de
	ET_MOD_UNKNOWNx14			= 0x14, // http://www.haspepapa-welt.de
	ET_MOD_UNKNOWNx17			= 0x17, // http://www.haspepapa-welt.de
	ET_MOD_UNKNOWNx2F			= 0x2F, // eMule v0.30 [OMEGA v.07 Heiko]
	ET_MOD_UNKNOWNx30			= 0x30, // aMule 1.2.0
	ET_MOD_UNKNOWNx36			= 0x36, // eMule v0.26
	ET_MOD_UNKNOWNx3C			= 0x3C, // enkeyDev.6 / LamerzChoice 9.9a
	ET_MOD_UNKNOWNx41			= 0x41, // CrewMod (pre-release mod based on Plus) identification
	ET_MOD_UNKNOWNx42			= 0x42, // CrewMod (pre-release mod based on Plus) key verification
	ET_MOD_UNKNOWNx43			= 0x43, // CrewMod (pre-release mod based on Plus) version info
	ET_MOD_UNKNOWNx50			= 0x50, // Bionic 0.20 Beta]
	ET_MOD_UNKNOWNx59			= 0x59, // emule 0.40 / eMule v0.30 [LSD.12e]
	ET_MOD_UNKNOWNx5B			= 0x5B, // eMule v0.26
	ET_MOD_UNKNOWNx5C			= 0x5C, // LSD-MOD
	ET_MOD_UNKNOWNx60			= 0x60, // eMule v0.30a Hunter.6 + eMule v0.26
	ET_MOD_UNKNOWNx64			= 0x64, // LSD.9dT / Athlazan(0.29c)Alpha.3
	ET_MOD_UNKNOWNx76			= 0x76, // http://www.haspepapa-welt.de (DodgeBoards)
	ET_MOD_UNKNOWNx84			= 0x84, // eChanblardv3.2
	ET_MOD_UNKNOWNx85			= 0x85, // ? 
	ET_MOD_UNKNOWNx86			= 0x86, // ? 
	ET_MOD_UNKNOWNx91			= 0x91, // DarkMule v6 |eVorte|X|
	ET_MOD_UNKNOWNx92			= 0x92, // DarkMule v6 |eVorte|X|
	ET_MOD_UNKNOWNx93			= 0x93, // ?
	ET_MOD_UNKNOWNxA0			= 0xA0, // --CeeK--(eMule v0.28)
	ET_MOD_UNKNOWNxA1			= 0xA1, // eMule v0.30 [eWombatBeta 0.064.A]
	ET_MOD_UNKNOWNxA6			= 0xA6, // eMule v0.26
	ET_MOD_UNKNOWNxB1			= 0xB1, // Bionic 0.20 Beta]
	ET_MOD_UNKNOWNxB4			= 0xB4, // Bionic 0.20 Beta]
	ET_MOD_UNKNOWNxC8			= 0xC8, // Bionic 0.20 Beta]
	ET_MOD_UNKNOWNxC9			= 0xC9, // Bionic 0.20 Beta]
	ET_MOD_UNKNOWNxDA			= 0xDA, // Rumata (rus)(Plus v1f) - leecher mod?
};

enum _EnumFriendTags
{
	FF_NAME		= 0x01,
};
typedef EnumDomain<_EnumFriendTags>	EnumFriendTags;

typedef EnumDomain<_EnumEmuleTags>	EnumEmuleTags;

// [Bloodymad Featureset
// [bloodymad] Sends as QR a estimated waiting time
#define EF_SENDSWAITTIME		0x00000001	// not used by emuleplus
// end mod tags

// emuleapp <-> emuleapp
#define OP_ED2KLINK				12000
#define OP_CLCOMMAND		    12001

//#endregion

//#region menu command message #s
//	Menu commands
#define MP_MESSAGE				10102
#define MP_DETAIL				10103
#define MP_ADDFRIEND			10104
#define MP_REMOVEFRIEND			10105
#define MP_SHOWLIST				10106
#define MP_CANCEL				10201
#define MP_STOP					10202
#define MP_RESUME				10204
#define MP_PAUSE				10203
#define	MP_CLEARCOMPLETED		10205
#define	MP_OPEN					10206
#define	MP_PREVIEW				10207
#define MP_DOWNNOW				10211
#define MP_SAVELOG				10212
#define MP_SAVERTF				10213
#define MP_OPENFOLDER 			10214
#define MP_CUSTOMIZETOOLBAR		10215
#define MP_SELECTTOOLBARBITMAPDIR 10216
#define MP_SELECTTOOLBARBITMAP	10217
#define MP_NOTEXTLABELS			10218
#define MP_TEXTLABELS			10219
#define MP_TEXTLABELSONRIGHT	10220
#define MP_TOOLBARBITMAP		10221
#define MP_CHANGEDIR			10222
#define MP_SHELLCONTEXT			10223
#define MP_DOCLEANUP			10224
#define MP_INITIALIZE			10225
#define MP_PREALLOCATE			10226
#define MP_FAKE_CHECK			10227
#define MP_FAKE_REPORT			10228
#define MP_SMARTFILTER			10229
#define MP_SRCFILTER_UPLOADING	10230
#define MP_SRCFILTER_ONQUEUE	10231
#define MP_SRCFILTER_FULLQUEUE	10232
#define MP_SRCFILTER_CONNECTED	10233
#define MP_SRCFILTER_CONNECTING	10234
#define MP_SRCFILTER_NNP		10235
#define MP_SRCFILTER_TOOMANYCONN 10236
#define MP_SRCFILTER_LOWTOLOWID	10237
#define MP_SRCFILTER_BANNED		10238
#define MP_SRCFILTER_ERROR		10239
#define MP_SRCFILTER_A4AF		10240
#define MP_SRCFILTER_UNKNOWN	10241
#define MP_SRCFILTER_HIDEALL	10242
#define MP_SRCFILTER_SHOWALL	10243

#define Irc_Version				"(SMIRCv00.65)"
#define Irc_Op					10240
#define Irc_DeOp				10241
#define Irc_Voice				10242
#define Irc_DeVoice				10243
#define Irc_HalfOp				10244
#define Irc_DeHalfOp			10245
#define Irc_Kick				10246
#define Irc_Slap				10247
#define Irc_Join				10248
#define Irc_Close				10249
#define Irc_Priv				10250
#define Irc_AddFriend			10251
#define	Irc_SendLink			10252
#define Irc_SetSendLink			10253
#define	Irc_Owner				10254
#define Irc_DeOwner				10255
#define	Irc_Protect				10256
#define Irc_DeProtect			10257

#define MP_PRIOVERYLOW			10300
#define MP_PRIOLOW				10301
#define MP_PRIONORMAL			10302
#define MP_PRIOHIGH				10303
#define MP_PRIOAUTO				10404 // Tarod
#define MP_PRIOVERYHIGH			10304
#define MP_GETED2KLINK			10305
#define MP_GETHTMLED2KLINK		10306
#define	MP_GETSOURCEED2KLINK 	10299
#define MP_METINFO				10307
#define MP_PERMALL				10308
#define MP_PERMFRIENDS			10309
#define MP_PERMNONE				10310
#define MP_CONNECTTO			10311
#define MP_REMOVE				10312
#define MP_REMOVEALL			10313
#define MP_REMOVESELECTED		10314
#define MP_UNBAN				10315
#define MP_ADDTOSTATIC			10316
#define MP_CLCOMMAND			10317
#define MP_UPDATEQQUEUE			10318
#define MP_RENAME				10319
#define MP_METINFOSOURCES		10320
	
//Category tab menu
#define MP_CAT_ADD				10321
#define MP_CAT_EDIT				10322
#define MP_CAT_REMOVE			10323
#define MP_RESUMENEXT			10324
#define MPG_DELETE				10325
#define	MP_COPYSELECTED			10326
#define	MP_SELECTALL			10327
#define	MP_AUTOSCROLL			10328
#define MPG_ALTENTER			10330
#define MP_REMOVEFROMSTATIC		10402
#define MP_VIEWFILECOMMENTS 	10403

//For comments 
#define MP_CMT              	10400
#define MP_SWITCHCTRL			10401

//--- xrmb:partTraffic ---
#define MP_SFL_CLEARSTATS		10600
#define MP_SFL_CLEARALLSTATS	10601
//--- :xrmb ---
//--- xrmb:allyaknow ---
#define MP_SFL_ALLYAKNOW		10610
#define MP_SFL_MERGEKNOWN		10611
#define MP_SFL_DELKNOWN			10612
//--- :xrmb ---
//--- xrmb:partprio ---
#define MP_SFL_PARTON			10621
#define MP_SFL_PARTOFF			10622
#define MP_SFL_PARTHIDDEN		10623
//--- :xrmb ---

#define MP_WEBURL				10700 //japg2000 (+64 BEWARE: taking up to 10763)
#define MP_WEBURL_LAST			10763

//Filter sub-menu
#define MP_FILTER_NONE			10764
#define MP_FILTER_BANNED		10765
#define MP_FILTER_FRIEND		10766
#define MP_FILTER_CREDIT		10767

//Category sub-menu
#define MP_ASSIGNCAT			10800
#define MP_LASTASSIGNCAT		10899
#define MP_SHOWPREDEFINEDCAT_0	10900
#define MP_SHOWPREDEFINEDCAT_LAST 10999
#define MP_CAT_SET_0			11000
#define MP_CAT_SET_LAST			11099

#define MP_ASK_FOR_FILES		11002
#define MP_ALL_A4AF_TO_HERE		11003
#define MP_DROPNONEEDEDSRCS		11004
#define MP_ALL_A4AF_AUTO		11005
#define MP_MOVIE				11006
#define MP_DROP_SUPERCOMPRESSED	11007

//#endregion

//thread messages
#define	TM_FINISHEDHASHING		(WM_APP+10)
#define TM_HASHTHREADFINISHED	(WM_APP+20)
#define TM_SOURCEHOSTNAMERESOLVED (WM_APP+1450)

// Quick Speed Changer
#define MP_QS_PA				10533
#define MP_QS_UA				10534

//Proxytypes
enum _EnumProxyTypes
{
	PROXYTYPE_NOPROXY	= 0,
	PROXYTYPE_SOCKS4	= 1,
	PROXYTYPE_SOCKS4A	= 2,
	PROXYTYPE_SOCKS5	= 3,
	PROXYTYPE_HTTP11	= 4,
};
typedef EnumDomain<_EnumProxyTypes>		EnumProxyTypes;

//#region Windows message IDs
//
//	Windows message IDs
//

//Asynchronous UI update messages
#define WM_SFL_UPDATEOFFEREDITEMS	(WM_USER + 2000)
#define WM_SFL_UPDATEITEM			(WM_USER + 2001)
#define WM_DL_REFRESH				(WM_USER + 2002)
#define WM_CL_REFRESH				(WM_USER + 2003)
//#define WM_UL_REFRESH				(WM_USER + 2004)		LATER
//#define WM_QL_REFRESH				(WM_USER + 2005)		LATER
//#define WM_DL_UPDATESOURCEITEM		(WM_USER + 2002)
//#define WM_DL_UPDATEFILEITEM		(WM_USER + 2003)
//#define WM_CL_REFRESHCLIENT			(WM_USER + 2004)
#define WM_UL_REFRESHCLIENT			(WM_USER + 2005)
#define WM_QL_REFRESHCLIENT			(WM_USER + 2006)

//kuchin/purity
#define WEB_CONNECT_TO_SERVER	WM_USER + 7001
#define WEB_REMOVE_SERVER		WM_USER + 7002
#define WEB_SHARED_FILES_RELOAD	WM_USER + 7003
#define WEB_ADD_TO_STATIC		WM_USER + 7004
#define WEB_REMOVE_FROM_STATIC	WM_USER + 7005
#define WEB_CLEAR_COMPLETED		WM_USER + 7006
//#endregion

#define PR_VERYLOW			4 // I Had to change this because it didn't save negative number correctly.. Had to modify the sort function for this change..
#define SRV_PR_LOW			2
#define PR_LOW				0 //*
#define PR_NORMAL			1 // Don't change this - needed for edonkey clients and server!
#define SRV_PR_NORMAL		0
#define	PR_HIGH				2 //*
#define SRV_PR_HIGH			1
#define PR_VERYHIGH			3
#define PR_AUTO				5 //UAP Hunter
#if JUMPSTART
	#define PR_JUMPSTART	6
#endif

#define PR_PART_ON 			0
#define PR_PART_HIDDEN		1
#define PR_PART_OFF			2

#define L2HAC_DEFAULT_EMULE		(FILEREASKTIME)
#define L2HAC_MIN_TIME			900000
#define L2HAC_MAX_TIME			3600000
#define L2HAC_CALLBACK_PRECEDE	(CONNECTION_TIMEOUT >> 1)
#define L2HAC_PREPARE_PRECEDE	(CONNECTION_TIMEOUT)

//eklmn: statistic section
#define STATS_DL_SOURCES_TYPE		19
#define STATS_DL_DATA_INFO			9
//average calculation
#define AVG_SESSION					0
#define AVG_TIME					1
#define AVG_TOTAL					2	// -khaos--+++> For the total average

enum _EnumDLQState
{
// downloadstate
	DS_DOWNLOADING	=	0,
	DS_ONQUEUE			 ,
	DS_CONNECTED		 ,
	DS_CONNECTING		 ,
	DS_WAITCALLBACK		 ,
	DS_REQHASHSET		 ,
	DS_NONEEDEDPARTS	 ,
	DS_TOOMANYCONNS		 ,
	DS_LOWTOLOWIP		 ,
	DS_BANNED			 ,
	DS_ERROR			 ,
	DS_NONE				 ,

	DS_LASTSTATE
};
typedef EnumDomain<_EnumDLQState>		EnumDLQState;

enum _EnumULQState
{
	// uploadstate
	US_UPLOADING		=	0,
	US_ONUPLOADQUEUE		 ,
	US_WAITCALLBACK			 ,	
	US_CONNECTING			 ,
	US_PENDING				 ,	
	US_LOWTOLOWIP			 ,
	US_BANNED				 ,
	US_ERROR				 ,	
	US_NONE					 ,
	US_LAST					
};
typedef EnumDomain<_EnumULQState>		EnumULQState;
